﻿using System.ComponentModel;
using System.Runtime.CompilerServices;
using WpfApplication5.Annotations;

namespace WpfApplication5
{
    internal abstract class ViewModelBase<T> : ViewModelBase
    {
        public T Model { get; private set; }

        protected ViewModelBase(T model)
        {
            Model = model;
        }
    }

    internal class ViewModelBase : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        [NotifyPropertyChangedInvocator]
        protected virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (handler != null) handler(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
